import { ModalName } from '@/types/modal';
import { MapOverlay } from '@/types/models';
import { PayloadAction } from '@reduxjs/toolkit';
import { ErrorData } from '@/utils/error-report/ErrorData';
import { BoundingBox } from '@/components/Map/MapViewer/MapViewer.types';

export type OverviewImagesModalState = {
  imageId?: number;
};

export type MolArtModalState = {
  uniprotId?: string | undefined;
};

export type ErrorRepostState = {
  errorData?: ErrorData | undefined;
};

export type EditOverlayState = MapOverlay | null;

export type LayerFactoryState = {
  id: number | undefined;
};

export type LayerImageObjectFactoryState = BoundingBox | undefined;

export type LayerTextFactoryState = BoundingBox | undefined;

export interface ModalState {
  isOpen: boolean;
  modalName: ModalName;
  modalTitle: string;
  overviewImagesState: OverviewImagesModalState;
  molArtState: MolArtModalState;
  errorReportState: ErrorRepostState;
  editOverlayState: EditOverlayState;
  layerFactoryState: LayerFactoryState;
  layerImageObjectFactoryState: LayerImageObjectFactoryState;
  layerTextFactoryState: LayerTextFactoryState;
}

export type OpenEditOverlayModalPayload = MapOverlay;

export type OpenEditOverlayModalAction = PayloadAction<OpenEditOverlayModalPayload>;
